Imports FarPoint.Win.Spread.CellType

Public Class Form1

    Private m_DataSet As New DataSet

    Private m_ComboBoxCellType As ComboBoxCellType
    Private m_MultiColumnComboBoxCellType As MultiColumnComboBoxCellType

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            m_DataSet.ReadXml("..\..\TestData.xml")

            With Me.FpSpread1

                .ButtonDrawMode = FarPoint.Win.Spread.ButtonDrawModes.CurrentRow

                .DataSource = m_DataSet.Tables("Customers")
                With .ActiveSheet
                    .RowHeader.Columns.Add(0, 1)
                    Dim view As DataView = .GetDataView(False)
                    For index As Integer = 0 To view.Count - 1
                        .RowHeader.Cells(index, 0).Value = view(index)(1)
                    Next
                    .RowHeader.Columns(0).Width = .RowHeader.Columns(0).GetPreferredWidth
                End With
            End With
            Me.radClear.Checked = True

            Dim data(m_DataSet.Tables("Customers").Rows.Count - 1) As String
            For index As Integer = 0 To m_DataSet.Tables("Customers").Rows.Count - 1
                data(index) = m_DataSet.Tables("Customers").Rows(index)("CustomerID").ToString
            Next
            m_ComboBoxCellType = New ComboBoxCellType
            m_ComboBoxCellType.Items = data

            m_MultiColumnComboBoxCellType = New MultiColumnComboBoxCellType
            With m_MultiColumnComboBoxCellType
                .ColumnEdit = 1
                .DataColumn = 1
                .ListWidth = 600
                .MaxDrop = 12
                .DataSourceList = m_DataSet.Tables("Customers")
            End With

        Catch ex As Exception
            Throw
        End Try
    End Sub 'Form1_Load

    Private Sub FpSpread1_CellClick(ByVal sender As Object, ByVal e As FarPoint.Win.Spread.CellClickEventArgs) Handles FpSpread1.CellClick
        With Me.FpSpread1.ActiveSheet
            Dim dataCellType As Object = .GetCellType(e.Row, 1)
            Dim headerCellType As Object = .RowHeader.Columns(0).CellType
            Dim dataText As String = "Nothing", headerText As String = "Nothing"
            If dataCellType IsNot Nothing Then dataText = dataCellType.GetType.FullName
            If headerCellType IsNot Nothing Then headerText = headerCellType.GetType.FullName
            MsgBox("Data: " & dataText & vbNewLine & "Header: " & headerText)
        End With
    End Sub 'FpSpread1_CellClick

    Private Sub radclear_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radClear.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radClear.Checked Then
                .RowHeader.Columns(0).CellType = Nothing
                .Columns(1).CellType = Nothing
            End If
            Me.Refresh()
        End With
    End Sub 'radclear_CheckedChanged

    Private Sub radempty_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radEmpty.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radEmpty.Checked Then
                .RowHeader.Columns(0).CellType = New EmptyCellType
                .Columns(1).CellType = New EmptyCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radempty_CheckedChanged

    Private Sub radGeneral_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radGeneral.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radGeneral.Checked Then
                .RowHeader.Columns(0).CellType = New GeneralCellType
                .Columns(1).CellType = New GeneralCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radGeneral_CheckedChanged

    Private Sub radPercent_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radPercent.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radPercent.Checked Then
                .RowHeader.Columns(0).CellType = New PercentCellType
                .Columns(1).CellType = New PercentCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radPercent_CheckedChanged

    Private Sub radNumber_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radNumber.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radNumber.Checked Then
                .RowHeader.Columns(0).CellType = New NumberCellType
                .Columns(1).CellType = New NumberCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radNumber_CheckedChanged

    Private Sub radComboBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radComboBox.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radComboBox.Checked Then
                .RowHeader.Columns(0).CellType = m_ComboBoxCellType ' New ComboBoxCellType
                .Columns(1).CellType = m_ComboBoxCellType ' New ComboBoxCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radComboBox_CheckedChanged

    Private Sub radButton_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radButton.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radButton.Checked Then
                Dim button As New ButtonCellType
                button.Text = "Delete"
                .RowHeader.Columns(0).CellType = button
                .Columns(1).CellType = New ButtonCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radButton_CheckedChanged

    Private Sub radCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radCheckBox.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radCheckBox.Checked Then
                .RowHeader.Columns(0).CellType = New CheckBoxCellType
                .Columns(1).CellType = New CheckBoxCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radCheckBox_CheckedChanged

    Private Sub radDateTime_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radDateTime.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radDateTime.Checked Then
                .RowHeader.Columns(0).CellType = New DateTimeCellType
                .Columns(1).CellType = New DateTimeCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radDateTime_CheckedChanged

    Private Sub radMultiColumnComboBox_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles radMultiColumnComboBox.CheckedChanged
        With Me.FpSpread1.ActiveSheet
            If Me.radMultiColumnComboBox.Checked Then
                .RowHeader.Columns(0).CellType = m_MultiColumnComboBoxCellType ' New MultiColumnComboBoxCellType
                .Columns(1).CellType = m_MultiColumnComboBoxCellType ' New MultiColumnComboBoxCellType
            End If
            Me.Refresh()
        End With
    End Sub 'radMultiColumnComboBox_CheckedChanged

End Class